[LiteJS]: https://www.litejs.com/
[npm package]: https://npmjs.org/package/litejs
[GitHub repo]: https://github.com/litejs/litejs
[wiki]: https://github.com/litejs/litejs/wiki
[RFC 6570]: http://tools.ietf.org/html/rfc6570


    @version    18.2.6
    @date       2018-02-27


LiteJS
======

The best way to build fast and powerful web interfaces.

Weighing in at just 28KB (12KB gzipped),
it includes everything you need to build a modern web application:

 - routed views with browser history management
 - reusable templates by custom element tags
 - asynchronous and dynamic code loading
 - translations with instant language switching - no page reload required
<details>
    <summary>.. and more with no dependencies</summary>

 - [date parsing and formating](https://github.com/litejs/litejs/wiki/Date)
 - string formating
 - [keyboard shortcuts](https://github.com/litejs/litejs/wiki/Keyboard-shortcuts)

</details>
<p></p>

See a [working example](https://cdn.rawgit.com/litejs/litejs/master/ui/example1.html)
with a [source code](https://github.com/litejs/litejs/blob/master/ui/example1.html)
in 80 lines.

It also supports SVG elements,
so it is possible to build full SVG single-page applications.  
See a [example](https://cdn.rawgit.com/litejs/litejs/master/ui/svg-example1.html)
with a [source code](https://github.com/litejs/litejs/blob/master/ui/svg-example1.html)
in 60 lines.



Get Started
-----------

Build your first LiteJS app with in 5 minute [Quick Start Guide](https://github.com/litejs/litejs/wiki/Quick-Start).

```
npm install -g litejs
litejs init demo-project
cd demo-project
npm start
```

See [wiki][] for more.



External links
--------------

 - [GitHub repo][]
 - [npm package][]
 - URI Template [RFC 6570][]


### Licence

Copyright (c) 2013-2018 Lauri Rooden &lt;lauri@rooden.ee&gt;  
[The MIT License](http://lauri.rooden.ee/mit-license.txt)


