// https://github.com/globalizejs/globalize

function i18n(text, lang) {
	lang = i18n[i18nGet(lang) || currentLang]
	return lang[text] ||
	text && lang[text = text.slice(text.indexOf("|") + 1) || text] ||
	text || ""
}

function i18nGet(lang) {
	return lang && (
		i18n[lang = ("" + lang).toLowerCase()] ||
		i18n[lang = lang.split("-")[0]]
	) && lang
}

function i18nUse(lang) {
	lang = i18nGet(lang)
	if (lang && currentLang != lang) {
		i18n[currentLang = i18n.current = lang] = i18n[currentLang] || {}
	}
	return currentLang
}

function i18nAdd(lang, texts) {
	if (i18n.list.indexOf(lang) == -1) i18n.list.push(lang)
	JSON.merge(i18n[lang] || (i18n[lang] = {}), texts)
	if (!currentLang) i18nUse(lang)
}

i18n.list = []
i18n.get = i18nGet
i18n.use = i18nUse
i18n.add = i18nAdd
i18n.def = function(map, key) {
	for (key in map) {
		i18nAdd(key, map)
	}
}
// navigator.userLanguage for IE, navigator.language for others
// var lang = navigator.language || navigator.userLanguage;
// i18nUse("en")
//*/
