#! /usr/bin/env node

process.chdir(__filename.replace(/\/[^\/]*$/, ""))

var litejs = require("litejs")
, app = module.exports = litejs.app({
	errors: {
		"Error": { code: 500 }
	}
})
, log = litejs.debug("main")
, logRequest = litejs.debug("http:req")


log("---\nStarting [" + process.pid + "] on", process.arch, process.platform, JSON.stringify(process.versions, null, 2))
log("Config", JSON.stringify(process.config))


app
.use(app.catchErrors)
.use(app.initRequest)
.use(function(req, res, next) {
	res.on("finish", function() {
		// var isSSL = req.socket.encrypted
		// var isSSL = this instanceof https.Server
		// var isSSL = this === httpsServer
		logRequest(req.ip, req.method, req.url, res.statusCode, (+new Date() - req.date) + "ms") // res._contentLength
	})
	next()
})
.use(app.readBody)
.post("/errlog", function(req, res, next) {
	log("UI ERROR\n" + req.body)
	res.end("OK")
})
.use(app.static("../ui"))


if (module === require.main) {
	app.listen()
}


