
console.log('Appcache service started', self);
var CACHE_NAME

function readManifest(file) {
	console.log("readManifest", file)
	return fetch(file)
	.then(function(res) {
		return res.text()
		.then(parseManifest)
	})
}

function parseManifest(text) {
	var files
	, match = text.match(/#\s*([^\n\r]+)/)
	, version = match && match[1] || "v1"

	if (CACHE_NAME !== version) {
		console.log("NEW MANIFEST", CACHE_NAME, "->", version)
		CACHE_NAME = version
		return caches.open(CACHE_NAME)
		.then(function(cache) {
			var files = text.match(/^(?![#*]|CACHE MANIFEST|\w+:)[^\n\r]+/gm)
			console.log("CACHE FILES", files)
			return cache.addAll(files)
		})
		.then(function() {
			// skipWaiting will cause activate to happen immediately
			self.skipWaiting()
		})
		.then(function() {
			self.clients.matchAll().then(all => all.forEach(client => {
				client.postMessage("updateready")
			}))
		})
	}
}

self.addEventListener("install", function(event) {
	event.waitUntil(readManifest("cache.manifest"))
})

self.addEventListener("activate", function(event) {
	console.log("ACTIVATE", CACHE_NAME)
	event.waitUntil(
		caches.keys()
		.then(function(keyList) {
			return Promise.all(keyList.map(function(key) {
				if (key !== CACHE_NAME) {
					console.log("DELETE CACHE", key)
					return caches.delete(key)
				}
			}))
		})
	)
})

self.addEventListener("fetch", function(event) {
	event.respondWith(
		caches.match(event.request)
		.then(function(response) {
			if (!response) console.log("Cache miss", event.request.url)
			return response || fetch(event.request)
		})
	)
})

self.addEventListener("message", function(event) {
	var op = event.data.op || event.data
	if (op === "load") {
		readManifest("cache.manifest")
		//event.source.postMessage("Responding to " + event.data)
	} else if (op === "update") {
		// self.clients.claim will make the new service worker take effect immediately on any open pages in its scope
		self.clients.claim()
		self.clients.matchAll().then(all => all.forEach(client => {
			client.postMessage("reload")
		}))
	}
})

self.addEventListener('push', function(event) {
  console.log('Received a push message', event);

  var title = 'Yay a message.';
  var body = 'We have received a push message.';
  var icon = '/images/icon-192x192.png';
  var tag = 'simple-push-demo-notification-tag';

  event.waitUntil(
    self.registration.showNotification(title, {
      body: body,
      icon: icon,
      tag: tag
    })
  );
});

